Package org.zkoss.stateless.sul

## Interface ITreechildren

- All Superinterfaces:
    `IChildable<ITreechildren,​ITreeitem>`, `IComponent<ITreechildren>`, `IHtmlBasedComponent<ITreechildren>`, `IMeshComposite<ITreechildren>`, `ITreeComposite<ITreechildren>`, `ITreeitemComposite<ITreechildren>`, `IXulElement<ITreechildren>`

      public interface ITreechildren
      extends IXulElement<ITreechildren>, IChildable<ITreechildren,​ITreeitem>, ITreeComposite<ITreechildren>, ITreeitemComposite<ITreechildren>

  Immutable `Treechildren` component
  Author:
    jumperchen
  See Also:
    `Treechildren`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `ITreechildren.Builder` | Builds instances of type `ITreechildren`.
    `static class` | `ITreechildren.Updater` | Builds an updater of type `ITreechildren` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ITreechildren` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default int` | `getItemCount()` | Returns the number of child `ITreeitem` including all descendants.
    `default java.util.Collection<ITreeitem>` | `getItems()` | Returns a readonly list of all descending `ITreeitem` (children's children and so on).
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static ITreechildren` | `of​(java.lang.Iterable<? extends ITreeitem> children)` | Returns the instance with the given tree items which belong to this component.
    `static ITreechildren` | `of​(ITreeitem... children)` | Returns the instance with the given tree items which belong to this component.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final ITreechildren DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.sel.Treechildren"`

      Specified by:
        `getWidgetClass` in interface `IComponent<ITreechildren>`

    - #### getItemCount

          @Lazy
          default int getItemCount()

      Returns the number of child `ITreeitem` including all descendants. The same as `getItems()`.size().

      Note: the performance is no good.

    - #### getItems

          @Lazy
          default java.util.Collection<ITreeitem> getItems()

      Returns a readonly list of all descending `ITreeitem` (children's children and so on).

      Note: the performance of the size method of returned collection is no good.

    - #### of

          static ITreechildren of​(java.lang.Iterable<? extends ITreeitem> children)

      Returns the instance with the given tree items which belong to this component.
      Parameters:
        `children` - The tree items of the component.

    - #### of

          static ITreechildren of​(ITreeitem... children)

      Returns the instance with the given tree items which belong to this component.
      Parameters:
        `children` - The tree items of the component.